/**
 * @file actor.h
 * Header file for Actor class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */
#ifndef _ACTOR_H
#define _ACTOR_H

/**
 * Anything "tickable".
 *
 * All Objects and Fields derive from this.  The game will maintain a list
 * of actors, all of which will tick each pass through the game loop.
 */
class Actor {
public:
    /**
     * This is called every game loop, with however many seconds
     * passed since the last call.
     */
    virtual void tick(double t) = 0;
};

#endif // header guard
