/**
 * @file box.cpp
 * Implementation of Box class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */

#include "box.h"
#include "model.h"
#include "scene.h"

Box::Box( Model *model, Vec3 position, dMatrix3 orientation, double scale, double mass ) :
    Object( model, position, orientation, scale, mass )
{
    dMass massStruct;

    Vec3 length = model->get_max() - model->get_min();

    dMassSetBoxTotal( &massStruct, mass, length[ 0 ], length[ 1 ], length[ 2 ] );

    dBodySetMass( _body_id, &massStruct );

    _geom_id = dCreateBox( get_space_id(), length[ 0 ], length[ 1 ], length[ 2 ] );

    dGeomSetBody( _geom_id, _body_id );

    dGeomSetPosition( _geom_id, position[ 0 ], position[ 1 ], position[ 2 ] );

    dGeomSetRotation( _geom_id, orientation );
}

Box::~Box( void )
{

}

void Box::tick( double t )
{

}

EffectHandler Box::get_effect_handler( Effect *effect )
{
    return Object::get_effect_handler( effect );
}
