/**
 * @file cylinder.h
 * Header file for Cylinder class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */
#ifndef _CYLINDER_H
#define _CYLINDER_H

#include "object.h"

// NOTE: the model for the cylinder *must* be length-aligned along the z-axis,
// class also assumes the model is a sphere-capped cylinder (capsule)
class Cylinder : public Object {
public:

    Cylinder( Model *model, Vec3 position = Vec3( 0.0, 0.0, 0.0 ), dMatrix3 orientation = NULL, double scale = 1.0, double mass = 1.0 );
    ~Cylinder( void );

    virtual void tick( double t );

    virtual EffectHandler get_effect_handler( Effect *effect );

private:

};

#endif // header guard
