/**
 * @file mouse.cpp
 * Implementation of Mouse class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */

#include "mouse.h"
#include "meateffect.h"
#include "model.h"

Material green(
        Vec4f( 0.0f, 0.0f, 0.0f, 1.0f ),
        Vec4f( 0.025f, 0.45f, 0.025f, 1.0f ),
        Vec4f( 0.025f, 0.45f, 0.025f, 1.0f ),
        Vec4f( 0.025f, 0.45f, 0.025f, 1.0f ),
        30.0f);

Model mouse_model(green);

Mouse::Mouse(Vec3 position) :
    Animal( &mouse_model, position, 5.0 )
{
    _speed = 1.0;
}

void Mouse::tick(double t)
{
    MeatEffect effect( this, 10 );
    effect.apply_to_all();
}

EffectHandler Mouse::get_effect_handler(Effect *effect)
{
    if ( IS_FEAR_EFFECT( effect ) ) {
        return (EffectHandler)&Mouse::_handle_fear_effect;
    }
    if ( IS_VEGGIE_EFFECT( effect ) ) {
        return (EffectHandler)&Mouse::_handle_veggie_effect;
    }
    return Animal::get_effect_handler( effect );
}

void Mouse::_handle_fear_effect(FearEffect *effect)
{
    /*
    if ( effect->get_scariness() < 1 ) {
        return;
    }

    Vec3 where = effect->get_origin();
    Vec3 dir = where - _position;

    if ( norm2( dir ) > 100*100 ) {
        // it's more than 100 meters away.. we don't care.
        return;
    }

    unitize( dir );
    this->step( -dir ); // run away
    */
}

void Mouse::_handle_veggie_effect(VeggieEffect *effect)
{
    /*
    Vec3 where = effect->get_origin();
    Vec3 dir = where - _position;

    if ( norm2( dir ) > 100*100 ) {
        // it's more than 100 meters away.. we don't care.
        return;
    }

    unitize( dir );
    this->step( dir ); // run towards
    */
}
