/**
 * @file mouse.h
 * Header file for Mouse class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */
#ifndef _MOUSE_H
#define _MOUSE_H

#include "animal.h"
#include "feareffect.h"
#include "veggieeffect.h"

class Mouse : public Animal {
public:
    Mouse(Vec3 position);

    void tick(double t);

    virtual EffectHandler get_effect_handler(Effect *effect);
private:
    void _handle_fear_effect(FearEffect *effect);
    void _handle_veggie_effect(VeggieEffect *effect);
};

#endif // header guard
