/**
 * @file heateffect.h
 * Header for HeatEffect class.
 *
 * Copyright 2003 by GameBuilders.
 * Distributed WITHOUT WARRANTY under the GPL.  See COPYING for details.
 */
#ifndef _HEATEFFECT_H
#define _HEATEFFECT_H

#include "powereffect.h"

/**
 * When something is heating an object.
 */
class HeatEffect : public PowerEffect {
public:
    HeatEffect() { }
    HeatEffect(Actor *sender, int temp) : PowerEffect( sender, temp ) { }

    /**
     * @return how hot it is
     */
    int get_temperature()
        { return get_magnitude(); }

    virtual RecList& get_receiver_list()
        { return _receiver_list; }
private:
    static RecList _receiver_list;
};

#define TO_HEAT_EFFECT(pobj)    TO_EFFECT(pobj, HeatEffect)
#define IS_HEAT_EFFECT(pobj)    TO_HEAT_EFFECT(pobj)

#endif // header guard
