#ifndef _GAMESTATE_H
#define _GAMESTATE_H

#include "level.h"

enum State {
    MAIN = 0,
    LEVEL_LOADING,
    GAMEPLAY,
    END_LEVEL,
    END_GAME,
    LEVEL_SELECT,
    HELP,
    OPTIONS_VIDEO_SOUND,
    OPTIONS_CONTROLS,
    ESC_DIALOG,
    RUN_SIM
}; 

class GameState {
public:

    GameState( void );

    ~GameState( void );

    const State get_current_state( void ) const { return _current_state; }
    const State get_previous_state( void ) const { return _previous_state; }

    void set_current_state( const State state ) { _current_state = state; }
    void set_previous_state( const State state ) { _previous_state = state; }

    void change_state( const State state );

    void load_level( const string filename );

    Level* get_level( void );

    void tick( void );

    void reset_sim( void );

    void reset_level( void );

public:

    State _current_state, _previous_state;

    Level* _current_level;

};

#endif



