#include "goal.h"

Goal::Goal( int ID, GoalType goal_type, int object_id, Vec3 position, double radius ) :
    _id( ID ), _goaltype( goal_type ), _object_id( object_id ), _position( position), _radius( radius )
{

}

Goal::~Goal( void )
{

}

bool Goal::check_goal( const Object* goal_object )
{
    bool completed = false;

    if( !goal_object )
        return completed;

    // should probably be using inheritance instead of switching on types
    switch( _goaltype )
    {
    case INSIDE:

        if( norm( goal_object->get_position() - _position ) < _radius )
            completed = true;

        break;

    case OUTSIDE:

        if( norm( goal_object->get_position() - _position ) > _radius )
            completed = true;

        break;

    case ACTIVATE:

        if( goal_object->is_on() )
            completed = true;

        break;

    case DEACTIVATE:

        if( !goal_object->is_on() )
            completed = true;

        break;

    default:

        completed = false;

        break;
    }

    return completed;
}
