#ifndef _GOAL_H
#define _GOAL_H

#include <gfx/vec3.h>

enum GoalType {
    INSIDE,
    OUTSIDE,
    ACTIVATE,
    DEACTIVATE
};

#include "object.h"

class Goal {
public:

    Goal( int ID, GoalType goal_type, int object_id, 
            Vec3 position = Vec3( 0.0, 0.0, 0.0 ), double radius = 0.0 );

    ~Goal( void );

    bool check_goal( const Object* object );

    int get_object_id( void ) { return _object_id; }

public:

    int _id;

    GoalType _goaltype;

    int _object_id;

    Vec3 _position;

    double _radius;

}; 

#endif

