#ifndef _LEVEL_H
#define _LEVEL_H

#include <ClanLib/core.h>

#include <map>
#include <string>

#include "main.h"
#include "object.h"
#include "actor.h"
#include "goal.h"

class Level {
public:

    typedef map<int, Object*> ObjectList;
    typedef map<int, Actor*> ActorList;
    typedef map<int, Goal*> GoalList;
    typedef ObjectList::iterator ObjectIterator;
    typedef ActorList::iterator ActorIterator;
    typedef GoalList::iterator GoalIterator;

    Level( string filename );

    ~Level( void );

    const bool level_completed( void );

    ObjectList& get_objects( void ) { return _objects; }
    ActorList& get_actors( void ) { return _actors; }
    int get_level_id( void ) const { return _id; }
    string get_filename( void ) const { return _filename; }
    string get_description( void ) const { return _description; }

    void reset_sim( void );

    void reset_level( void );

public:

    int _id;

    string _filename;

    string _description;

    GoalList _goals;
    ObjectList _objects;
    ActorList _actors;

    Vec3 _world_size;

    double _camera_radius;
    double _camera_elevation;
    double _camera_azimuth;
};

#endif // header guard
