#ifndef _MATERIAL_H
#define _MATERIAL_H

#include "main.h"

#include <gfx/vec4.h>

#include <string>
using namespace std;

class Material {
public:
    Vec4f ambient;    ///< Fraction of ambient light reflected
    Vec4f diffuse;    ///< Fraction of incoming light reflected diffusely 
    Vec4f specular;   ///< Fraction of incoming light reflected specularly
    Vec4f emissive;   ///< Light emitted by this material

    double shininess;   ///< Exponent for Phong illumination model

    uint texture;     ///< OpenGL texture index
    string texture_file;    ///< Filename of texture, for reloading

    Material() {}
    Material(Vec4f amb, Vec4f diff, Vec4f spec, Vec4f emit, double shiny);
    Material(const Material& mat);

    void make_current() const;
};

#endif // header guard
