#include "sphericalcamera.h"


SphericalCamera::SphericalCamera( Vec3f center, float radius, float theta, float phi, 
        float fov,
        float near_plane, float far_plane,
        int screen_width, int screen_height,
        ProjType proj_type ) 
: FPSCamera( Vec3f( 0, 0, 0 ), Vec3f( 0, 0, 0 ), Vec3f( 0, 0, 0 ), 
        fov, near_plane, far_plane, screen_width, screen_height, proj_type )
{
    this->center = center;
    this->radius = radius;
    this->theta = theta;
    this->phi = phi;
}

SphericalCamera::~SphericalCamera( void )
{

}

void SphericalCamera::rotate_view( float angle )
{
    return;
}

void SphericalCamera::rotate_view( float angle, Vec3f rotate_vec )
{
    return;
}

void SphericalCamera::move( float speed )
{
    return;
}

void SphericalCamera::move( float speed, Vec3f move_vec )
{
    return;
}

void SphericalCamera::mouse_look( Vec2f where, Vec2f last, int which )
{
    switch( which )
    {
    case 1:
        this->theta += (float) ( where[ 0 ] - last[ 0 ] ) / this->screen_width * M_PI;

        this->phi += (float) ( where[ 1 ] - last[ 1 ] ) / this->screen_height * M_PI;
        break;

    case 2:
        this->radius += (float) ( where[ 1 ] - last[ 1 ] );
        break;
    }
}

void SphericalCamera::look( void )
{
    // flip the Y and Z as the opengl coordinate system is defined differently
    // from the spherical coordinate system
    float pos_x = this->radius * cos( this->theta ) * sin( this->phi );
    float pos_z = this->radius * sin( this->theta ) * sin( this->phi );
    float pos_y = this->radius * cos( phi );

    float up_x = cos( this->theta ) * cos( this->phi );
    float up_z = sin( this->theta ) * cos( this->phi );
    float up_y = -sin( this->phi );

    gluLookAt( pos_x + this->center[ 0 ], pos_y + this->center[ 1 ], pos_z + this->center[ 2 ],
            this->center[ 0 ], this->center[ 1 ], this->center[ 2 ],
            -up_x, -up_y, -up_z ); 
}
